/* p_arith_s.c
 * Pointer-Arithmetik SOLARIS
 *
 * Zerlegung einer short int-Zahl 
 * in das niederwertige und das hoeherwertige Byte
 */

#include <stdio.h>

int main () {
  short zahl, * ptr; 	// ptr ist vom Typ Pointer auf short
  
  zahl = 0x3FED;	// an Adresse von Zahl wird Wert gespeichert
  ptr = &zahl;		// ptr zeigt auf Adresse von zahl

  printf("\nZahl ist: %x \n", zahl);
  printf("Pointer zeigt auf die Adresse: %p \n", ptr);
  
  // Pointer fuer die Bytes einrichten
  unsigned char * low;
  unsigned char * high;
  void * dummy; 	// untypisierter Pointer

  // Pointertyp-Konvertierung
  dummy = ptr;		// referenziert gesamten Adressraum wie ptr
  high = dummy;		// unterses Byte des ptr-Adressraums
  low = high + 1; 	// oberes Byte des ptr-Adressraums

  // Ausgabe
  printf("\nPointer low zeigt auf die Adresse: %p \n", low);
  printf("Der Inhalt an der Adresse von low ist: %x \n", *low);

  printf("\nPointer high zeigt auf die Adresse: %p \n", high);
  printf("Der Inhalt an der Adresse von high ist: %x \n", *high);
  printf("\n");

  return 0;
}

